#!/bin/sh

# some vars (global) to work with
NCD_tmp="NCD_tmp.txt"; WCD_tmp="WCD_tmp.txt"; i=""; j=""; c=0;

NIC_rmv(){
    # start fresh
    NIC_fle="$1"
    if [ "$NIC_fle" == "NCD" ] ; then
        if [ -e "$NCD_tmp" ]; then
                rm $NCD_tmp
                touch $NCD_tmp
                sleep 1
        fi
    fi
    if [ "$NIC_fle" == "WCD" ] ; then
        if [ -e "$WCD_tmp" ]; then
                rm $WCD_tmp
                touch $WCD_tmp
                sleep 1
        fi
    fi
}

NIC_attached(){
  # 02    Network Controller Device
  NIC_run="NCD";
  
  # although i wrote this script I am not happy to searching the description
  NCD_src=`sysctl -a dev | grep class=0x02`

  NIC_rmv $NIC_run

  for i in $NCD_src; do
        echo ${i} >> $NCD_tmp
  done

  i=""; NCD_typ="Wired";
  NCD_fld=$(grep ":" $NCD_tmp | awk -F : '{ print $1 }')

  if [ ! -z "$NCD_fld" ]; then
    NIC_rmv $NIC_run
    for i in $NCD_fld; do
      NCD_dev=$(echo ${i} | cut -d'.' -f2)
      NCD_cnt=$(echo ${i} | cut -d'.' -f3)
      NCD_dsc=$(sysctl -a dev.${NCD_dev}.${NCD_cnt}.%desc | cut -d':' -f2)

      NCD_eql=$(pciconf -lv ${NCD_dev}${NCD_cnt} | grep device)
      if [ ! -z "$NCD_eql" ]; then
        NCD_pci=$(echo "${NCD_eql}" | cut -d'=' -f2)
        NCD_pci=$(echo "${NCD_pci}" | sed "s/\'//g")
      else
        NCD_pci="${NCD_dsc}"
      fi

      for j in $NCD_pci; do
        if [ "$j" == "Wireless" ] ; then
          NCD_typ="Wireless"
        fi
      done

      echo "${NCD_dev}${NCD_cnt}:${NCD_dev}.${NCD_cnt}:${NCD_pci}:Attached:${NCD_typ}" >> $NCD_tmp
    done
  fi
}

NIC_unattached(){
  # Find unattached devices
  i=""; NIC_run="WCD"; WCD_max=9;
  WCD_src=$(pciconf -lv | grep class=0x02)

  NIC_rmv $NIC_run

  for i in $WCD_src; do
        echo ${i} >> $WCD_tmp
  done

  i="";WCD_typ="Wired";
  WCD_fld=$(grep ":" $WCD_tmp | awk -F : '{ print $1 }')

  if [ ! -z "$WCD_fld" ]; then
    for i in $WCD_fld; do
      WCD_nme=$(grep "${i}" $WCD_tmp)
      WCD_sta=$(pciconf -a ${WCD_nme} | cut -d' ' -f2 -f3 -f4)
      WCD_sta=$(echo "$WCD_sta" | sed "s/ //g")
      if [ "$WCD_sta" == "notattached" ] ; then
        WCD_sta="Unattached"
      fi

      # device description
      WCD_eql=$(pciconf -lv ${WCD_nme} | grep device)
      WCD_dsc=$(echo ${WCD_eql} | cut -d'=' -f2)
      WCD_dsc=$(echo "$WCD_dsc" | sed "s/\'//g")

      #

      WCD_dev=$(echo ${i} | cut -d'@' -f1)
      NCD_res=$(grep "${WCD_dev}" $NCD_tmp)

      # if no results from grep, should be a new device
      k=""; j="";
      if [ -z "$NCD_res" ]; then
        # search for wirless
        # ?better to grep subdevice=0x000d or pciconf ... grep card=0x000d?
        for k in $WCD_dsc; do
          if [ "$k" == "Wireless" ] ; then
            WCD_typ="Wireless"
          fi
        done

        # This will not work if double digits
        for j in $(seq 1 $WCD_max); do

          if [ ! -z $(echo ${WCD_dev} | grep ${j}) ]; then
            WCD_two=$(echo "$WCD_dev" | sed "s/$j/\.$j/g")
            echo "${WCD_dev}:${WCD_two}:${WCD_dsc}:${WCD_sta}:${WCD_typ}" >> $NCD_tmp
          fi

        done
      fi
    done
  fi

  rm ${WCD_tmp}
}

NIC_echo(){
  echo "TMP FILE CONTENTS:"
  echo "---------------------------------------------------------------------------------------------------"
  cat $NCD_tmp
  echo "---------------------------------------------------------------------------------------------------"
}
# Example usage of data colected in tmp file:

XMP_exm(){
  i=""
  NCD_xmp=$(grep ":" $NCD_tmp | awk -F : '{ print $1 }')
  echo ""
  echo "-------------------------------------------------------------------------------"

  for i in $NCD_xmp; do
    c=`expr $c + 1`
    XMP_dsc=$(grep "${i}" $NCD_tmp | awk -F : '{ print $3 }')
    XMP_sta=$(grep "${i}" $NCD_tmp | awk -F : '{ print $4 }')
    XMP_typ=$(grep "${i}" $NCD_tmp | awk -F : '{ print $5 }')
    echo "[${c}] [${i}] ${XMP_dsc} - [${XMP_sta}] - [${XMP_typ}]"
  done
  echo ""
  echo "Select Network Controller Device to work with"
  echo "Enter the number coresponding to network device listed above (default [1]):"
  read XMP_sel

  if [ -z "$XMP_sel" ]; then
    XMP_sel=1
  fi

  # lets grab selected record
  i=""; c=0;
  XMP_xmp=$(grep ":" $NCD_tmp | awk -F : '{ print $1 }')

  for i in $XMP_xmp; do
    c=`expr $c + 1`
    if [ "$XMP_sel" -eq "$c" ] ; then
      XMP_dev=$(grep "${i}" $NCD_tmp | awk -F : '{ print $1 }')
      XMP_dsc=$(grep "${i}" $NCD_tmp | awk -F : '{ print $3 }')
      XMP_sta=$(grep "${i}" $NCD_tmp | awk -F : '{ print $4 }')
      XMP_typ=$(grep "${i}" $NCD_tmp | awk -F : '{ print $5 }')
      XMP_lne="${XMP_dev} ${XMP_dsc} - [${XMP_sta}] - [${XMP_typ}]"
    fi
  done

  echo ""
  echo "ALL NETWORK ADAPTERS:"
  echo "-------------------------------------------------------------------------------"
  cat $NCD_tmp
  echo "-------------------------------------------------------------------------------"
  echo ""; echo ""
  echo "SELECTED DEVICE:"
  echo "-------------------------------------------------------------------------------"
  echo "${XMP_lne}"
  echo "-------------------------------------------------------------------------------"

  CON_funk $XMP_dev $XMP_sta $XMP_typ

}

CON_test(){
  i=""; CON_dev="$1"; CON_sta="$2"; CON_typ="$3"; CON_do1="none"; CON_err="";

  if [ "$CON_typ" != "Wireless" ] ; then
    CON_err="Cannot process ${CON_typ} devices"
    CON_do1="err"
  fi
  if [ "$CON_sta" == "Unattached" ] ; then
    CON_err="${CON_err} Cannot process ${CON_sta} ${CON_typ} devices!"
    CON_do1="err"
  fi

  if [ "$CON_do1" == "none" ] ; then
    CON_arr=$(grep ":" $NCD_tmp | awk -F : '{ print $1 }')

      # bring down all interfaces
      ifconfig wlan0 down
      for i in $CON_arr; do
        ifconfig $i down
        sleep 1
      done

      # bring up selected device
      ifconfig $CON_dev up

      # connection
      ifconfig $CON_dev

      ifconfig wlan0 destroy
      ifconfig wlan0 create wlandev ${CON_dev}
      ifconfig wlan0 inet 10.40.1.129 netmask 255.255.255.0 ssid AHR-50

      ifconfig wlan0 up list scan
      sleep 3

      ifconfig ${CON_dev}; echo ""; echo "";
      ifconfig wlan0; echo ""; echo "";

      # restart
      wpa_supplicant -B -i wlan0 -c /etc/wpa_supplicant.conf -D bsd
      #/etc/rc.d/netif restart wlan0
      #/etc/rc.d/wpa_supplicant restart wlan0
    else
      echo "${CON_err}"
    fi
}

CON_funk(){
  # this is just for now to see some results -- CON_test() is inactive
  # only simulation as there is no actions completed
  i=""; CON_dev="$1"; CON_sta="$2"; CON_typ="$3"; CON_do1="none"; CON_err="";

  if [ "$CON_typ" != "Wireless" ] ; then
    CON_err="Cannot process ${CON_typ} devices"
    CON_do1="err"
  fi
  if [ "$CON_sta" == "Unattached" ] ; then
    CON_err="${CON_err} Cannot process ${CON_sta} ${CON_typ} devices!"
    CON_do1="err"
  fi

  if [ "$CON_do1" == "none" ] ; then
    CON_arr=$(grep ":" $NCD_tmp | awk -F : '{ print $1 }')

      echo "SIMULATION/TODO: bring down all interfaces"
      for i in $CON_arr; do
        echo "'ifconfig' ${i} down"
        sleep 1
      done
      echo "";
      
      echo "SIMULATION/TODO: bring up selected device ${CON_dev}"
      echo "'ifconfig' ${CON_dev} up"

      echo "SIMULATION/TODO: create connection on ${CON_dev}"

      # restart
    else
      echo "${CON_err}"
    fi
    
    # cleanup
    rm $NCD_tmp
}
NIC_attached
NIC_unattached
XMP_exm
echo ""; echo "";
